TChain* chain;
void LoadRootFiles();
void LoadCuts();

TCutG* cut44;
TCutG* cut40;
TCutG* cut10Be[8];

double Exo_EDC_vamos;
double Exo_EDC_pista;
int FPMW_Section;
int Telescope;
double FF_Mass;
double FF_DE;
double FF_Eres;
int m_2alpha;
double DeltaEcorr;
double Elab;


///////////////////////////////////////////
void LoadRootFiles(string part="part1")
{
  chain = new TChain("PhysicsTree");
  if(part=="part1"){
    chain->Add("../../root/analysis/run_28.root");
    chain->Add("../../root/analysis/run_29.root");
    chain->Add("../../root/analysis/run_30.root");
    chain->Add("../../root/analysis/run_31.root");
    chain->Add("../../root/analysis/run_32.root");
    chain->Add("../../root/analysis/run_36.root");
    chain->Add("../../root/analysis/run_37.root");
    chain->Add("../../root/analysis/run_39.root");
    chain->Add("../../root/analysis/run_41.root");
    chain->Add("../../root/analysis/run_42.root");
    chain->Add("../../root/analysis/run_43.root");
    chain->Add("../../root/analysis/run_44.root");
    chain->Add("../../root/analysis/run_45.root");
    chain->Add("../../root/analysis/run_46.root");
    chain->Add("../../root/analysis/run_48.root");
    chain->Add("../../root/analysis/run_49.root");
    chain->Add("../../root/analysis/run_50.root");
    chain->Add("../../root/analysis/run_51.root");
    chain->Add("../../root/analysis/run_52.root");
    chain->Add("../../root/analysis/run_53.root");
  }
  else if(part=="part2"){
    chain->Add("../../root/analysis/run_55.root");
    chain->Add("../../root/analysis/run_56.root");
    chain->Add("../../root/analysis/run_57.root");
    chain->Add("../../root/analysis/run_58.root");
    chain->Add("../../root/analysis/run_59.root");
    chain->Add("../../root/analysis/run_60.root");
    chain->Add("../../root/analysis/run_61.root");
    chain->Add("../../root/analysis/run_62.root");
    chain->Add("../../root/analysis/run_63.root");
    chain->Add("../../root/analysis/run_64.root");
    chain->Add("../../root/analysis/run_65.root");
    chain->Add("../../root/analysis/run_66.root");
    chain->Add("../../root/analysis/run_67.root");
    chain->Add("../../root/analysis/run_68.root");
    chain->Add("../../root/analysis/run_69.root");
  }
}

///////////////////////////////////////////
void LoadCuts(string part)
{
  TFile* ifile = new TFile("cut44.root");
  cut44 = (TCutG*) ifile->FindObjectAny("cut44");
  ifile->Close();

  ifile = new TFile("cut40.root");
  cut40 = (TCutG*) ifile->FindObjectAny("cut40");
  ifile->Close();

  string path = "cut/" + part + "/cut10Be.root";
  TFile* fcut = new TFile(path.c_str());
  for(int i=0; i<8; i++){
    cut10Be[i]= (TCutG*) fcut->Get(Form("cut10Be_det%i",i+1));
  }
}

///////////////////////////////////////////
void check_gamma(string part="part1")
{
  LoadCuts(part);
  LoadRootFiles(part);

  TString ofile_name = Form("mass_check_%s.root",part.c_str());
  TFile* ofile  = new TFile(ofile_name,"recreate");
  TH2F* hmass44 = new TH2F("hmass44","hmass44",20,0,20,1000,60,160);
  TH2F* h108    = new TH2F("h108","h108",20,0,20,500,0,2000);
  TH2F* h106    = new TH2F("h106","h106",20,0,20,500,0,2000);
  TH2F* h100    = new TH2F("h100","h100",20,0,20,500,0,2000);
  TH2F* h98     = new TH2F("h98","h98",20,0,20,500,0,2000);

  TH1F* hg108   = new TH1F("hg108","hg108",500,0,2000);
  TH1F* hg106   = new TH1F("hg106","hg106",500,0,2000);
  TH1F* hg100   = new TH1F("hg100","hg100",500,0,2000);
  TH1F* hg98    = new TH1F("hg98","hg98",500,0,2000);
  TH1F* hg10Be  = new TH1F("hg10Be","hg10Be",1000,0,4000);

  chain->SetBranchStatus("Exo_EDC_vamos",true);
  chain->SetBranchAddress("Exo_EDC_vamos",&Exo_EDC_vamos);
  chain->SetBranchStatus("Exo_EDC_pista",true);
  chain->SetBranchAddress("Exo_EDC_pista",&Exo_EDC_pista);
  chain->SetBranchStatus("FPMW_Section",true);
  chain->SetBranchAddress("FPMW_Section",&FPMW_Section);
  chain->SetBranchStatus("FF_Mass13",true);
  chain->SetBranchAddress("FF_Mass13",&FF_Mass);
  chain->SetBranchStatus("FF_DE",true);
  chain->SetBranchAddress("FF_DE",&FF_DE);
  chain->SetBranchStatus("FF_Eres",true);
  chain->SetBranchAddress("FF_Eres",&FF_Eres);
  chain->SetBranchStatus("Telescope",true);
  chain->SetBranchAddress("Telescope",&Telescope);
  chain->SetBranchStatus("m_2alpha",true);
  chain->SetBranchAddress("m_2alpha",&m_2alpha);
  chain->SetBranchStatus("DeltaEcorr",true);
  chain->SetBranchAddress("DeltaEcorr",&DeltaEcorr);
  chain->SetBranchStatus("Elab",true);
  chain->SetBranchAddress("Elab",&Elab);

  int nentries = chain->GetEntries();

  for(int i=0; i<nentries; i++){
    if(i%100000==0) cout << i*100./nentries << "% \r" << flush;
    chain->GetEntry(i);

    if(m_2alpha==0 && cut10Be[Telescope-1]->IsInside(Elab,DeltaEcorr)){
      hg10Be->Fill(Exo_EDC_pista);
    }

    if(cut44->IsInside(FF_Eres,FF_DE)){
      hmass44->Fill(FPMW_Section,FF_Mass);
      if(abs(FF_Mass-108)<0.5){
        h108->Fill(FPMW_Section,Exo_EDC_vamos);
        hg108->Fill(Exo_EDC_vamos);
      }
      else if(abs(FF_Mass-106)<0.5){
        h106->Fill(FPMW_Section,Exo_EDC_vamos);
        hg106->Fill(Exo_EDC_vamos);
      }
    }

    else if(cut40->IsInside(FF_Eres,FF_DE)){
      if(abs(FF_Mass-100)<0.5){
        h100->Fill(FPMW_Section,Exo_EDC_vamos);
        hg100->Fill(Exo_EDC_vamos);
      }
      else if(abs(FF_Mass-98)<0.5){
        h98->Fill(FPMW_Section,Exo_EDC_vamos);
        hg98->Fill(Exo_EDC_vamos);
      }
    }
  }

  hmass44->Write();
  h108->Write();
  h106->Write();
  h100->Write();
  h98->Write();

  hg108->Write();
  hg106->Write();
  hg100->Write();
  hg98->Write();

  hg10Be->Write();

  ofile->Close();
}
