#include <vector>
double TransfoX( double X, vector<double> &MinX ,vector<double> &MaxX ,vector<double> &ScalingBin ,vector<double> &NewMinX ,vector<double> &NewMaxX , vector<double> &Scale);
void CalculateNewBin(vector<double> &MinX,vector<double> &MaxX,vector<double> &NewMinX, vector<double> &NewMaxX ,vector<double> &BinWidth, vector<double> &ScalingBin, vector<double> &Scale );
void Linearisation2(int RunStart, int RunStop){
    //========================================================================
    //-------------------Open tree and define Hist----------------------------
    //======================================================================== 

    TChain *ch = new TChain("PhysicsTree"); 


    for(int run = RunStart ; run <= RunStop ; run++){
        ch->Add(Form("../../root/analysis/linea_%d.root",run));
    } //End of run loop

    std::vector<TH1F*> PositionX,PositionY;
    for (int i=1; i<=4; i++ ){
        std::string PosXName = "hPositionXDet" + std::to_string(i) ;
        std::string PosXTitle = "PositionXDet" + std::to_string(i) ;
        std::string PosYName = "hPositionYDet" + std::to_string(i) ;
        std::string PosYTitle = "PositionYDet" + std::to_string(i) ;
        TH1F * PosX;
        TH1F * PosY;
        if ( i==1 ){
            PosX = new TH1F(PosXName.c_str(),PosXTitle.c_str(),1000,0,40);
            PosY = new TH1F(PosYName.c_str(),PosYTitle.c_str(),1000,0,60);
        }//End if det 1

        if ( i==2 ){
            PosX = new TH1F(PosXName.c_str(),PosXTitle.c_str(),1000,0,63);
            PosY = new TH1F(PosYName.c_str(),PosYTitle.c_str(),1000,0,92);

        }//End if det 2

        if ( i==3 || i==4 ) {
            PosX = new TH1F(PosXName.c_str(),PosXTitle.c_str(),1000,-1000,0);
            PosY = new TH1F(PosYName.c_str(),PosYTitle.c_str(),1000,0,160);
        }//End if det 3 or 4

        PositionX.push_back(PosX);
        PositionY.push_back(PosY);
    }//End of i loop
    TH1F *ZoomDet1 = new TH1F("ZoomDet1","ZoomDet1",10,19,20);
    TH1F *ZoomDet1Adjusted = new TH1F("ZoomDet1Adjusted","ZoomDet1Adjusted",10,19,20);
    TH1F *VarBin;





    //========================================================================
    //-----------------------Importing conditional var------------------------
    //========================================================================
    TFPMWPhysics *FPMW = new TFPMWPhysics();
    ch->SetBranchAddress("FPMW",&FPMW);






    //========================================================================
    //--------------------------TreatEvent------------------------------------
    //========================================================================
    int Nentries = ch->GetEntries();
    int GoodEntries = 0, Bin2= 0,Bin2Treated=0;




    // Here we calculate the new bin edges
    size_t N = 10;
    vector<double> MinX, MaxX, NewMinX(N+1), NewMaxX(N), NewBinWidth, ScalingBin, Scale;    
    CalculateNewBin(MinX, MaxX, NewMinX, NewMaxX , NewBinWidth , ScalingBin, Scale);
    VarBin = new TH1F("VarBin", "VarBin", N, &NewMinX[0]);

    for (int i=0; i<N+1 ; i++){
        cout << "MinX[i]   " << MinX[i];
        cout << "  NewMinX[i]  " << NewMinX[i] << endl;
    }





    for (int entries=0; entries<Nentries; entries++){
        ch -> GetEntry(entries); 
        if(entries%100000==0){
            cout << "\033[92m\r Processing tree..." << (double)entries/Nentries*100 << "\% done" << flush;
        }//End cout loading


        if(FPMW->DetectorNbr.size()>0){
            GoodEntries += 1;
            for (int DetectorNbr = 0 ; DetectorNbr < FPMW->DetectorNbr.size() ; DetectorNbr ++){
                double X = FPMW->PositionX[DetectorNbr];
                double Y = FPMW->PositionY[DetectorNbr];

                if (DetectorNbr>=0 && DetectorNbr<4){
                    PositionX[DetectorNbr]->Fill(X); 
                    PositionY[DetectorNbr]->Fill(Y); 
                }





                if (FPMW->PositionX[DetectorNbr]>=19 && FPMW->PositionX[DetectorNbr]<=20 && DetectorNbr == 0 && true){ //Put && false if hist not prefilled
                    //cout << "******************************************" << endl;
                    double XNew = TransfoX(X , MinX, MaxX, ScalingBin, NewMinX, NewMaxX, Scale);
                    //cout << "Xnew after function " <<XNew << endl;
                    ZoomDet1->Fill(X);
                    ZoomDet1Adjusted->Fill(XNew);
                    VarBin->Fill(XNew);
                   
                    //for (int i ; i<=9 ; i++){
                    if (X >= MinX[2] && X< MaxX[2] && false){
                        Bin2 +=1;
                        cout << "Bin2 :" << Bin2 << " Bin2Treated: " << Bin2Treated << endl ;
                        cout << "MinX " << MinX[2] << " MaxX " << MaxX[2] << endl;
                        cout << "Xold " << X  <<endl ;
                        cout << "NewMinX " << NewMinX[2]<< " NewMaxX " << NewMaxX[2] << endl;
                        cout << "Xnew  " <<  XNew  << endl;
                        cout << endl << endl; 
                    }
                    if(XNew >= NewMinX[2] && XNew < NewMaxX[2]){
                        Bin2Treated += 1;
                    }
                    //}
                }
            } // Loop detnbr
        }//Non empty event

    }//End loop on entries



    cout << endl << "Good entries" << GoodEntries << endl;

    std::vector<TCanvas*> canvas;
    for (int i=0; i<4; i++ ){
        std::string CanvasName = "c" + std::to_string(i) ;
        TCanvas *c = new TCanvas(CanvasName.c_str(),CanvasName.c_str(),960,540);
        c -> Divide(2,1);
        canvas.push_back(c);


        canvas[i] -> cd(1);
        PositionX[i] -> Draw("logY");
        gPad->SetLogy();
        canvas[i] -> cd(2);
        PositionY[i] -> Draw("logY");
        gPad->SetLogy();

    }
    TCanvas * CZoom = new TCanvas("CZoom","CZoom",1860,540);
    CZoom -> Divide(3,1);
    CZoom -> cd(1);
    ZoomDet1 -> Draw();
    CZoom -> cd(2);
    ZoomDet1Adjusted -> Draw("*H");
    CZoom -> cd(3);
    VarBin -> Draw("*H");
    gStyle-> SetOptStat(11111111);


} // end macro

//========================================================================
//--------------------------TransfoX--------------------------------------
//========================================================================

double TransfoX( double X, vector<double> &MinX ,vector<double> &MaxX ,vector<double> &ScalingBin ,vector<double> &NewMinX ,vector<double> &NewMaxX , vector<double> &Scale){
    /*
       This take as input the original bin of the histogram and the new bin defined by the function CalculateNewBin
       And output the new calculated X 
       */
    double XNew = -1000;
    for (int i= 0 ; i<=9 ; i++){
        if (X>= MinX[i] && X< MaxX[i]){
            double Xold = X;
            double Scale2 = (X-MinX[i])/(MaxX[i]-MinX[i]);
            XNew = Scale2 * (NewMaxX[i] - NewMinX[i])+NewMinX[i] ;
            if (XNew < NewMinX[i] || XNew > NewMaxX[i]  ){
                cout << " FUNCTION  " << endl;
                cout << i << endl ;
                cout << "MinX " << MinX[i] << " MaxX " << MaxX[i] << endl;
                cout << "Xold " << Xold  <<endl ;
                cout << "NewMinX " << NewMinX[i]<< " NewMaxX " << NewMaxX[i] << endl;
                cout << "Xnew  " <<  XNew  << endl;
                cout << endl << endl;
            } 
        }
    }
    return XNew;
} //end transfo x


void CalculateNewBin(vector<double> &MinX,vector<double> &MaxX,vector<double> &NewMinX, vector<double> &NewMaxX ,vector<double> &NewBinWidth , vector<double> &ScalingBin, vector<double> &Scale){
    //Tentative proportionelle au NBIN
    double NBin[10] = {5227., 4416.0, 3388.0, 2634.0, 2168.0, 1858.0, 2392.0, 3063.0, 4219.0, 5402.0};
    double SumBin = 0 ,NTotBin ,TotWidth=0. , NewTotWidth=0., IndexLastBin =9;
    vector<double> BinWidth, NewBinWidthTheoretical;


    for (int i= 0 ; i<=IndexLastBin ; i++){
        double d = i ; 
        MinX.push_back( 19. + d/10.);
        MaxX.push_back( 19. + (d+1.)/10.);
        SumBin += NBin[i];
        BinWidth.push_back( MaxX[i] - MinX[i]);
        TotWidth += BinWidth[i];
    }   


    NTotBin = SumBin / (IndexLastBin + 1);
    NewMinX[0] = MinX[0];

    for (int i= 0 ; i<=IndexLastBin ; i++){
        ScalingBin.push_back(NBin[i] / NTotBin);
        NewBinWidthTheoretical.push_back(ScalingBin[i]*BinWidth[i]);

        if (i!=0){
            NewMinX[i] = NewMaxX[i-1];
        }
        double MaxXTemp = NewMinX[i] + 0.1; 
        Scale.push_back((NewMinX[i] + 0.1 * ScalingBin[i])/MaxXTemp);
        NewMaxX[i] =(NewMinX[i] + 0.1)* Scale[i];
        NewBinWidth.push_back(NewMaxX[i]-NewMinX[i]);
        NewTotWidth += NewBinWidth[i];

        cout << " itération " << i << endl;
        cout << " NewMin "  << NewMinX[i] << "  NewMax " << NewMaxX[i] << endl;
        cout << " Scaling  "<< Scale[i] <<  " NewBinWidth " << NewBinWidth[i] << endl;
        cout << " Width of bin " << NewBinWidth[i]<< "  expected width  " << NewBinWidthTheoretical[i] << endl;
        cout << endl << endl;

    }
    NewMinX[IndexLastBin+1] = NewMaxX[IndexLastBin];
}
