import numpy as np

x_prime = 1.68414
y_prime = 0.3327
file = "alpha_224Ra.source"

def compute_pos_source(x_prime,y_prime):
    x_FC = -1.9
    y_FC = 35.5
    z_FC = -0.99
    angle_FC = 35 * np.pi / 180

    x_source = x_FC
    y_source = y_FC + y_prime*np.sin(angle_FC)
    z_source = z_FC + y_prime*np.cos(angle_FC)
    return x_source,y_source,z_source


def update_position(filename, new_x0, new_y0, new_z0):
    # Read the file content
    new_x0 = round(new_x0, 5)
    new_y0 = round(new_y0, 5)
    new_z0 = round(new_z0, 5)
    with open(filename, 'r') as file:
        lines = file.readlines()

    # Update the lines with new x0, y0, z0 values
    for i in range(len(lines)):
        if lines[i].startswith(" x0="):
            lines[i] = f" x0= {new_x0}\n"
        elif lines[i].startswith(" y0="):
            lines[i] = f" y0= {new_y0}\n"
        elif lines[i].startswith(" z0="):
            lines[i] = f" z0= {new_z0}\n"

    # Write the updated content back to the file
    with open(filename, 'w') as file:
        file.writelines(lines)


x,y,z = compute_pos_source(x_prime,y_prime)
update_position(file,x,y,z)
