void plot_theta() {

  gStyle->SetOptStat(1111111);
  gStyle->SetOptFit(1);

  TFile *file = TFile::Open("./root/simulation/test_setup_Si45_2layers_50um.root");
//  TFile *file = TFile::Open("./root/simulation/test_setup_H_2Si.root");
  TTree *tree = (TTree*)file->Get("SimulatedTree");

//  tree->Draw("InteractionCoordinates.fDetected_Position_X[0]");
//  TLeaf *leaf = tree->GetLeaf("fDetected_Position_X");

  TInteractionCoordinates* DC;
  DC = new TInteractionCoordinates;
  tree->SetBranchAddress("InteractionCoordinates",&DC);

//  double z_distance = 49.393;  // Hydrogen distance
  double z_distance = 30.; // Silicon distance
  double z_diagonal;
  double theta;

  TH1D *h1 = new TH1D("h1","h1",100,-0.02,0.02);

  int nentries = tree->GetEntries();
  
  double x1,x2;
  double y1,y2;

  for (Int_t i = 0; i<nentries; i++) {
    tree->GetEntry(i);

//    cout <<"Position 0: " << DC->GetDetectedPositionX(0) << endl;
//    cout <<"Position 1: " << DC->GetDetectedPositionX(1) << endl;
    x1 = DC->GetDetectedPositionX(0);
    x2 = DC->GetDetectedPositionX(1);
    y1 = DC->GetDetectedPositionY(0);
    y2 = DC->GetDetectedPositionY(1);
    
    z_diagonal = sqrt( pow(z_distance,2.) + pow(x2 - x1, 2.) );
    theta = TMath::ATan( (y2 - y1) / z_diagonal ); 
    h1->Fill(theta);

//    cout << theta << endl;
  }
  h1->Draw();
  h1->Fit("gaus");

}
