#include "Plots_Functions.h"
#include "Plots_C2SFunctions.h"
#include "Plots_ParryFunctions.h"
#include "Plots_ConvoluteBreitWignerGaus.h"

void C2S(){
  cout << "======================================" << endl;
  cout << " Run C2S:" << endl;
  cout << " C2S( Ex, Spin, L, J, ExBin, \"option\", SpinIn, nAngB, wAngBin, fAngBin) " << endl;
  cout << "   standard values:                      2.5,    25,    2,       106  " << endl;
  cout << "======================================" << endl;
  cout << " -- 0.000 MeV, 0+, d5/2:  C2S(0.000,0,2,2.5,0.02,\"     \",2.5,17,2,116)  low&high angs bad" << endl;
  cout << " -- 1.675 MeV, 2+, d5/2:  C2S(1.675,2,2,2.5,0.02,\"     \",2.5,21,2,106)  high angs bad" << endl;
  cout << " -- 3.572 MeV, 4+, d5/2:  C2S(3.572,4,2,2.5,0.02,\"     \",2.5,24,2,106)  " << endl;
  cout << " -- 4.071 MeV, 2+, sdmx:  C2S(4.071,2,0,0.5,0.02,\"mixed\",2.5,24,2,106)" << endl;
  cout << " -- 4.456 MeV, 0+, xx/2:  C2S(4.456,0,2,2.5,0.02,\"     \",2.5, 6,8,106)   6p-2h state" << endl;
  cout << " -- 5.004 MeV, ?+, xx/2:  C2S(5.004,2,2,2.5,0.02,\"     \",2.5, 6,8,106)   " << endl;
  cout << " -- 5.228 MeV, ?+, s1/2:  C2S(5.228,2,0,0.5,0.02,\"mixed\",2.5,24,2,106)" << endl;
  cout << " -- 5.629 MeV, ?+, xx/2:  C2S(5.629,2,2,2.5,0.02,\"mixed\",2.5,24,2,106)" << endl;
  cout << " -- 7.252 MeV, 5-? xx/2:  C2S(7.252,5,2,1.5,0.02,\"     \",2.5,11,2,106)   Tilley: h-wave, but we pop via d-wave! 3/2 or 5/2?" << endl;
  cout << " -- 7.622 MeV, 4+? xx/2:  C2S(7.622,4,2,1.5,0.02,\"     \",2.5,11,2,106)" << endl;
  cout << " -- 7.855 MeV, 5-? xx/2:  C2S(7.855,2,0,0.5,0.02,\"     \",2.5,11,2,106) looks s-wave?? how?? 5- accoring to LaFrance" << endl;
  cout << " -- 8.313 MeV, ??? xx/2:  C2S(8.313,4,2,1.5,0.02,\"     \",2.5,11,2,106)" << endl;
  cout << "======================================" << endl;
}

void Plots_Experiment(){

  //Load in files
//LoadChain_Au();
//LoadChain_CD2();
//LoadChain_Both();
  LoadChain_Both_PaxmanAnalysis();
//  TCutG* cutPrompt = LoadCut_Prompt();
//  TCutG* cutTimeBoth = LoadCut_TimeBoth();
//  TCutG* cutBothBlobs = LoadCut_BothBlobs();
//  TCutG* cutPromptPlus = LoadCut_PromptPlus();
//  TCutG* cutGood = LoadCut_Good();
//  TCutG* cutBad = LoadCut_Bad();



  //== Assignments for Plots_KnownPeakFitter() ==
  means.reserve(meansGauss.size() + meansVoigt.size());
  means.insert(means.end(), meansGauss.begin(),meansGauss.end());
  means.insert(means.end(), meansVoigt.begin(),meansVoigt.end());

  numGauss = meansGauss.size();
  numVoigt = meansVoigt.size();
  numPeaks = numGauss + numVoigt;
  //=============================================



  cout << "======================================" << endl;
  cout << "Time gate GOOD = abs(T_FPMW_HF-13300)<1500" << endl;
  cout << "Time gate BAD  = abs(T_FPMW_HF-10500)<1500" << endl;
  cout << "======================================" << endl;
  cout << "USEFUL COMMANDS:::" << endl;
  cout << "  GateGamma_SeeParticle(0.005,0.10,0.09,0.03,0.14,0.03)" << endl;
  cout << "    --First excited decay of 19O, with background" << endl;
  C2S();
}
