#!/bin/bash

cd ~/Programs/nptoolv3/Projects/e775s/analysis;
rm ./InputFiles/Auto.runtotreat
rm ./InputFiles/AutoPSpace.reaction

sp=" "
dfile="./InputFiles/mugast_2024-09-06.detector"
rfile_exp="./InputFiles/e775s_2024-09-06.reaction"
rfile_sim="./InputFiles/AutoPSpace.reaction"

#Variables
E=$(echo "scale=3; $2/1000" | bc -l)
X="-3.8"
Y="-0.4"

#====================================================
# Symbolic link for mugast map
#----------------------------------------------------
# Remove old links
 rm ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastMap.h
 rm ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastReverseMap.h
#----------------------------------------------------
# Link "SIMU"
#echo "SYMBOLIC LINK: SIMU"
#ln -s ~/Programs/nptoolv3/NPLib/Detectors/Mugast/Zanon_Simu_MugastMap.h ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastMap.h
#ln -s ~/Programs/nptoolv3/NPLib/Detectors/Mugast/Zanon_Simu_MugastReverseMap.h ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastReverseMap.h
#----------------------------------------------------
# Link "ORIG"
 echo "SYMBOLIC LINK: ORIG"
 ln -s ~/Programs/nptoolv3/NPLib/Detectors/Mugast/Zanon_Orig_MugastMap.h ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastMap.h
 ln -s ~/Programs/nptoolv3/NPLib/Detectors/Mugast/Zanon_Orig_MugastReverseMap.h ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastReverseMap.h
#====================================================


#====================================================
echo -e "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" 		  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "Beam" 						  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""Particle=""$sp""19O" 			  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""ExcitationEnergy=""$sp""0""$sp""MeV" 	  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""Energy=""$sp""151.82""$sp""MeV" 		  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""SigmaEnergy=""$sp""0.0""$sp"" MeV" 	  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""SigmaThetaX=""$sp""0.0""$sp""deg" 	  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""SigmaPhiY=""$sp""0.0""$sp""deg"	 	  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""SigmaX=""$sp""1.5""$sp""millimeter" 	  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""SigmaY=""$sp""3.0""$sp""millimeter"	  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""MeanThetaX=""$sp""0""$sp""deg"	  	  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""MeanPhiY=""$sp""0""$sp""deg" 		  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""MeanX=""$sp""$X""$sp""millimeter" 	  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""MeanY=""$sp""$Y""$sp""millimeter" 	  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" 		  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "PhaseSpace"	 				  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""Beam=""$sp""19O" 				  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""Target=""$sp""2H" 			  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""Daughters=""$sp""1H""$sp""19O""$sp""n"	  	      >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""ExcitationEnergies=""$sp""0.0""$sp""$E""$sp""0.0""MeV"  >> ./InputFiles/AutoPSpace.reaction
echo -e "$sp""Fermi=""$sp""1" 			  	  	      >> ./InputFiles/AutoPSpace.reaction
#====================================================

cmake ./;
make -j6;

nameconstruct=$1"_"$2
echo "Name: $nameconstruct"
echo "Reaction file: $rfile_sim"
echo "Detector file: $dfile"

for x in 0 1 2 3 4 5 6 7 8 9
do
  outname=$nameconstruct"-"$x
  npsimulation -D $dfile -E $rfile_sim -B ./InputFiles/runPhaseSpace.mac --random-seed $RANDOM -O $outname;
  #npsimulation -D $dfile -E $rfile_sim -B ./InputFiles/runSimSmall.mac --random-seed $RANDOM -O $outname;
done

outfile="PSp_"$nameconstruct

echo "TTreeName"      >> ./InputFiles/Auto.runtotreat
echo " SimulatedTree" >> ./InputFiles/Auto.runtotreat
echo "RootFileName"   >> ./InputFiles/Auto.runtotreat

directory='/home/paxman/Programs/nptoolv3/Outputs/Simulation/'

for x in 0 1 2 3 4 5 6 7 8 9
do
  echo "$sp""$directory""$nameconstruct""-""$x"".root" >> ./InputFiles/Auto.runtotreat
done

npanalysis --definition PSp -R ./InputFiles/Auto.runtotreat -E $rfile_exp -D $dfile -O $outfile;

#mvname="./SolidAngleHistFiles/SAHF_"$outfile".root"
#mv ./SolidAngleHistFiles/SAHF_New.root $mvname

