/***************************************************************************
 *   Charlie Paxman (cp00474@surrey.ac.uk)                                 *
 ***************************************************************************/

//-------------------------------
//C++
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
using namespace std;
//-------------------------------

void EventReader(){

  // Read ROOT file and pull the tree	
    int breakEvent;
    string outname;
    auto DataFile = new TFile("../../../../Outputs/Analysis/47Kdp_25Jul23_5p5um_PartI.root", "READ"); breakEvent = 240178; outname = "./XYZE_5p5um_09Apr24_PartI.txt";
    //auto DataFile = new TFile("../../../../Outputs/Analysis/47Kdp_25Jul23_5p5um_PartII.root", "READ"); breakEvent = 1000000000000; outname = "./XYZE_5p5um_09Apr24_PartII.txt";

  auto PhysTree = (TTree*) DataFile->FindObjectAny("PhysicsTree");

  // Initilise the Mugast branch
  auto Mugast = new TMugastPhysics();

  // Initilise access variables for PhysTree
  static vector<double> *MWT;
  static double T_MUGAST_VAMOS;
  static double T_MUGAST_CATS2;
  static vector<double> *X, *Y, *Z, *RawEnergy, *AddBack_EDC, *ThetaLab;

  // Pull PhysTree branches
  auto Energy_Branch = PhysTree->GetBranch("RawEnergy");
  auto Gamma_Branch = PhysTree->GetBranch("AddBack_EDC");
  auto X_Branch = PhysTree->GetBranch("X");
  auto Y_Branch = PhysTree->GetBranch("Y");
  auto Z_Branch = PhysTree->GetBranch("Z");
  auto MWT_Branch = PhysTree->GetBranch("MWT");
  auto MugVam_Branch = PhysTree->GetBranch("T_MUGAST_VAMOS");
  auto MugCat_Branch = PhysTree->GetBranch("T_MUGAST_CATS2");
  auto ThetaLab_Branch = PhysTree->GetBranch("ThetaLab");

  // Set Mugast branch address
  PhysTree->SetBranchAddress("Mugast",&Mugast);

  // Set PhysTree variable addresses
  Energy_Branch->SetAddress(&RawEnergy);
  Gamma_Branch->SetAddress(&AddBack_EDC);
  X_Branch->SetAddress(&X);
  Y_Branch->SetAddress(&Y);
  Z_Branch->SetAddress(&Z);
  MWT_Branch->SetAddress(&MWT);
  MugVam_Branch->SetAddress(&T_MUGAST_VAMOS);
  MugCat_Branch->SetAddress(&T_MUGAST_CATS2);
  ThetaLab_Branch->SetAddress(&ThetaLab);

  // Build loop variables
  unsigned int numEntries = PhysTree->GetEntries();
  unsigned int multiplicity = 0;

  // Open output file
  ofstream outfile;
  outfile.open(outname.c_str());

  // Loop on entries
  for(unsigned int i=0; i<breakEvent; i++){
    PhysTree->GetEntry(i);
    multiplicity = Mugast->TelescopeNumber.size(); 

    // Loop on MUGAST multiplicity
    for(int m=0; m<multiplicity; m++){
      // Gate on Timing
      //if(abs(T_MUGAST_VAMOS-2700)<400){
        int gammaMultip = AddBack_EDC->size();
        //if(ThetaLab->at(m) <= 130. && ThetaLab->at(m) >= 100.){
          if(gammaMultip>=1){
	    // Gate on E_Gamma
	    if(abs(AddBack_EDC->at(0)-0.143) < 0.005){
	      outfile << Mugast->TelescopeNumber.at(m) << " " <<
	                 X->at(m) << " " <<
                         Y->at(m) << " " <<
	                 Z->at(m) << " " <<
	                 RawEnergy->at(m) << endl;
            }//if 0.143
          }//if gammamultip
	//}//if theta (new!! testing!!!
      //}//if timing
    }//for m
  }//for i
  outfile.close();

  cout << " --- COMPLETE --- " << endl;
}
