#include "TMath.h"
#include "math.h"
#include <cmath>
#include "stdlib.h"

bool removing = false;
bool bgForCS2 = true;
vector<double> fitContByBin; //each entry is a bin, containing eval of fit function in that bin for removal function
int numPeaks_temp = 0;

vector<double> means = { 0.000,
                           0.143,
                           //0.279,
			   //0.728,
			   0.967,
			   1.409,
			   1.978,
			   2.407,
			   2.909,
			   3.254,
			   3.601,
			   3.830,
			   //4.16,
			   //4.29,
			   //4.35
			   4.363
                           };
const int numPeaks = means.size(); 

vector<double> means_dt = {
	                   0.000,
	                   0.639,//FIT AS DOUBLET
	                   //0.587,
			   //0.691,
			   //0.886,
			   //1.370,
			   //1.554,//TESTING HALFWAY BETWEEN 1.37 AND 1.74
			   //1.738,
                           1.944,
			   2.233, 
			   2.732,
			   3.377,//DOUBLET
			   //3.330,//3.377,//DOUBLET
                           //3.344,
                           //3.409,
			   4.15
				   //4.15//4.297
                           };

const int numPeaks_dt = means_dt.size(); 

array<double,27> knowngammas = { 0.143,
					0.279,
					0.449,
					0.968,
					1.130,
					1.410,
					1.267,
					//0.575,
					1.013,
					1.838,
					1.981,
					1.000,
					2.412,
					2.767,
					2.518,
					3.325,
					2.878,
					3.605,
					2.839,
					2.734,
					3.522,
					3.076,
					3.875,
					0.834,
					3.325,
					3.77,
					4.037,
					4.364					
					};

/*
Double_t f_bg(Double_t *x, Double_t *par){
  // Flat bg [0] + semicircle [1]*sqrt(6.183^2 - (x-10.829)^2) 
  Float_t xx = x[0];
  Double_t f;
  Double_t a = TMath::Power(6.183,2);
  Double_t b = TMath::Power(xx-10.829,2);
  if(a > b){ f = par[0] + (par[1]*TMath::Sqrt(a-b)); }
  else{ f = par[0]; }
  return f;
}

Double_t f_peak(Double_t *x, Double_t *par){
  float xx = x[0];
  double f = (par[2]/(par[0]*sqrt(2*pi)))*exp(-0.5*pow((xx-par[1])/par[0],2));
  return f;
}
*/

string f_full_string(){
  string result = "gaus(0)";
  //for(int pk=1; pk<numPeaks; pk++){
  for(int pk=1; pk<numPeaks_temp; pk++){
    result += "+gaus(" + to_string(3*pk) + ")"; 
  }
  return result;
}

string f_full_pol2bg_string(){
  string result = "gaus(0)";
  for(int pk=1; pk<numPeaks; pk++){
    result += "+gaus(" + to_string(3*pk) + ")"; 
  }
  result += "    + [" + to_string(3*numPeaks+0) 
	 +  "]   + [" + to_string(3*numPeaks+1)
	 +  "]*x + [" + to_string(3*numPeaks+2)
	 +  "]*x*x";
  return result;
}

string f_full_pol4bg_string(){
  string result = "gaus(0)";
  for(int pk=1; pk<numPeaks; pk++){
    result += "+gaus(" + to_string(3*pk) + ")"; 
  }
//[0] * ( [1] + [2]*x + [3]*x*x + [4]*x*x*x + [5]*x*x*x*x)
  result += " + ([" + to_string(3*numPeaks+1) + "] "
         +  " +  [" + to_string(3*numPeaks+2) + "]*x "
         +  " +  [" + to_string(3*numPeaks+3) + "]*x*x "
         +  " +  [" + to_string(3*numPeaks+4) + "]*x*x*x "
         +  " +  [" + to_string(3*numPeaks+5) + "]*x*x*x*x "
         +  " ) * " + to_string(3*numPeaks+0) + "]";




//  result += "    + [" + to_string(3*numPeaks+0) 
//	 +  "]   *([" + to_string(3*numPeaks+1)
//	 +  "]   + [" + to_string(3*numPeaks+1)
//	 +  "]*x + [" + to_string(3*numPeaks+2)
//	 +  "]*x*x";
  return result;
}

string f_full_skewgaussbg_string(){
  string result = "gaus(0)";
  for(int pk=1; pk<numPeaks; pk++){
    result += "+gaus(" + to_string(3*pk) + ")"; 
  }
//"2.*gaus(x-[3],[0],0,[1])*ROOT::Math::normal_cdf([2]*(x-[3]),1,0)"
  result += " + 2.*gaus(x-[" 
	  + to_string(3*numPeaks+3) + "], ["
          + to_string(3*numPeaks+0) + "], 0 ,["
          + to_string(3*numPeaks+1) + "])*ROOT::Math::normal_cdf(["
          + to_string(3*numPeaks+2) + "]*(x-["
	  + to_string(3*numPeaks+3) + "]),1,0)";

  return result;
}

Double_t f_full(Double_t *x, Double_t *par) {
  float xx = x[0];
  double result, norm;
  result = 0;

  // Add N peaks
  for(int pk=0; pk<numPeaks; pk++){
    result += (par[1+(pk*3)]*exp(-0.5*pow(((xx-par[2+(pk*3)]-par[0])/par[3+(pk*3)]),2))); //REGULAR GAUS
  }
  return result;
}

//Double_t f_full_dt(Double_t *x, Double_t *par) {
//  float xx = x[0];
//  double result, norm;
//  // Flat background
////  result = par[0];
//  result = 0;
//  // Add N peaks
//  for(int pk=0; pk<numPeaks_dt; pk++){
//    result += (par[3+(pk*3)]/(par[1+(pk*3)]*sqrt(2*pi)))
//	      //* exp(-0.5*pow((xx-par[2+(pk*3)])/par[1+(pk*3)],2));
//	      * exp(-0.5*pow((xx-par[2+(pk*3)]-par[0])/par[1+(pk*3)],2)); //added par 0 as shift in energy
//  }
//  return result;
//}

vector<vector<double>> FitKnownPeaks_RtrnArry(TH1F* hist, double slideshift){
  double minFit, maxFit; 
  double binWidth = hist->GetXaxis()->GetBinWidth(3);
  //double sigma = 0.14;

  double sigma = 0.0;// = 0.14;
  numPeaks_temp = 0;
  vector<double> means_temp; 

  //Gradient on mean value
  double gradient;
  double intercept;
  if(reactionName=="47K(d,p)"){
    sigma = 0.14;
    //gradient = 0.989;
    gradient = 1.0;//0.989;
    intercept = 0.000;
    numPeaks_temp = numPeaks;
    means_temp = means;
    minFit = -1.0;
    maxFit = 4.644; 
  } else if (reactionName=="47K(d,t)"){
    sigma=0.16;//sigma = 0.18;
    //gradient = 0.986;
    gradient = 1.002; //0.995;//1.005;
    //gradient = 1.002; //0.995;//1.005;
    intercept = -0.060; //-0.055;//-0.061;
    numPeaks_temp = numPeaks_dt;
    means_temp = means_dt;
    minFit = -1.;
    maxFit = +10.; 
  }

  cout << BOLDGREEN 
       << "FITTING WITH A REAL:OBSERVED Ex GRADIENT GRADIENT OF " 
       << gradient 
       << RESET 
       << endl;

  //hist->Sumw2();

  //Build individual peak fit functions
  string nameBase = "Peak ";
  string function = "gaus";//"[0]*exp(-0.5*pow(((x-[1])/[2]),2))";//REGULAR GAUS
  TF1 **allPeaks = new TF1*[numPeaks_temp];
  for(int i=0; i<numPeaks_temp; i++) {
    string nameHere = nameBase;
    nameHere +=to_string(i);
    allPeaks[i] = new TF1(nameHere.c_str(), function.c_str(), minFit, maxFit);
    allPeaks[i]->SetLineColor(4001);  
    allPeaks[i]->SetLineStyle(7);  
    allPeaks[i]->SetNpx(500);
  } 

  //Subtract flat background equal to smallest bin in range
  if(!removing){
    TF1 *flat = new TF1 ("flat","[0]",5,8);
    cout << RED << "REMOVING FLAT BACKGROUND!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" << RESET << endl;
    if(reactionName=="47K(d,p)"){
      hist->GetXaxis()->SetRange(hist->FindBin(-0.8), hist->FindBin(-0.0));
      double bgmin = hist->GetBinContent(hist->GetMinimumBin());
      hist->GetXaxis()->UnZoom();
      cout << "Subtracting background of " << bgmin << endl;
      for(int b=1; b<hist->GetNbinsX() ; b++){
          hist->SetBinContent(b,hist->GetBinContent(b)-bgmin);
      }
    } else if(reactionName=="47K(d,t)"){
//      int count = 0;
//      int sum = 0;
//      cout << "here" << endl;
//      for(int b=hist->FindBin(5.0); b<hist->FindBin(7.0) ; b++){
//	sum += hist->GetBinContent(b);
//        count++;
//      }
//      double avg = (double)count / (double)sum;
//      cout << "Subtracting background of " << avg << endl;
//      for(int b=1; b<hist->GetNbinsX() ; b++){
//          hist->SetBinContent(b,hist->GetBinContent(b)-avg);
//	  if(hist->GetBinContent(b)<0){hist->SetBinContent(b,0);}
//      }

    }

  }

  //Build background function
  string backend_bgfuncstring;
  //if(bgForCS2){
      backend_bgfuncstring = "]"; //cout << "fitting with FLAT bg because makes no diff for CS2" << endl; 
  //} else {
    //backend_bgfuncstring = "]-0.478*(x-5.0)^2";                 //pol2
    //backend_bgfuncstring = "]*exp(-(x-4.5)^2/(2*(2.9^2)))";     //gaus     
    //backend_bgfuncstring = "]/4.5 * sqrt((4.5)^2 - (x-4.5)^2)"; //semicirc 
  //}
  string bgfuncstring;
  double bgminFit, bgmaxFit;
  if(reactionName=="47K(d,p)"){
    bgfuncstring = "[0]";
    bgminFit = minFit;
    bgmaxFit = maxFit;
  } else if(reactionName=="47K(d,t)"){
    bgfuncstring = "[0";
    if(!bgForCS2){bgfuncstring += backend_bgfuncstring;}
    else{bgfuncstring += "]";}
    bgminFit = 5.;
    bgmaxFit = 7.;
  }
  TF1 *bg = new TF1 ("bg",bgfuncstring.c_str(),bgminFit, bgmaxFit);
  bg->SetLineColor(kGreen);
  bg->SetLineStyle(9);
  bg->SetParNames("Background");
  //bg->SetParameter(0,10);
  //bg->SetParameter(0,-10);
  if(bgForCS2){bg->FixParameter(0,0);}
  hist->Fit(bg, "RBL", "", bgminFit, bgmaxFit);
  bg->SetRange(minFit,maxFit);
  cout << bg->GetParameter(0) << endl;
  
  //Build total function
  int bgRefNum = ((numPeaks_temp-1)*3)+3;
  string s_full = f_full_string();
  if(reactionName=="47K(d,p)"){
    //background?
  } else if(reactionName=="47K(d,t)"){
//    if(!bgForCS2){
//      string s_full = f_full_string();
      s_full.append(" + ([");
      s_full+=to_string(bgRefNum);
      //s_full.append("]/4.5 * sqrt(25.0 - (x-4.5)^2))");
//      s_full+=backend_bgfuncstring;
      s_full.append("])");
//    }
  }

  cout << "BG REF NUMBER " << bgRefNum << endl;
  cout << s_full << endl;

  TF1 *full = new TF1("fitAllPeaks", s_full.c_str(), minFit, maxFit);
  full->SetLineColor(4000);
  const int numParams = (numPeaks_temp*3);
  for(int i=0; i<numPeaks_temp; i++) {
    //full->FixParameter((i*3)+1,means_temp.at(i)*gradient);
    full->FixParameter((i*3)+1,(means_temp.at(i)*gradient) + intercept);
    full->FixParameter((i*3)+2,sigma);
    full->SetParameter((i*3)+0,1e1);
    full->SetParLimits((i*3)+0,0.0,1e5);
  }
  full->SetNpx(500);

  //Set and fix specific parameters
  for (int i=0; i<numPeaks; i++){
    if(reactionName=="47K(d,p)"){
      if(means[i]>4.0){
        full->SetParameter((i*3)+2,0.23);
      }
      if(abs(means[i]-0.279)<0.05){
        full->FixParameter((i*3)+0,0.0);
      }
      if(abs(means[i]-0.728)<0.05){
        full->FixParameter((i*3)+0,0.0);
      }
    } else if(reactionName=="47K(d,t)"){
      full->SetParLimits(bgRefNum,0,30);      
//        full->FixParameter(bgRefNum,0);      
      //if(abs(means[i]-1.55)<0.3){
      //  cout << "TESTING FORCE FOR FWAVE STATES!!!" << endl;
      //  full->SetParameter((i*3)+0,10.);
      //  full->SetParLimits((i*3)+0,0.0,50.);
      //}
      if(means[i]>4.0){
        cout << "HERE!! " << endl;
        full->SetParameter((i*3)+0,10.);
        full->SetParLimits((i*3)+0,0.0,50.);
      }
//      if(bgForCS2){full->FixParameter(bgRefNum,0);} 
//      else {
//        full->SetParLimits(bgRefNum,bg->GetParameter(0),bg->GetParameter(0));      
//        full->FixParameter(bgRefNum,bg->GetParameter(0));      
//        cout << "fixing to ...... " << bg->GetParameter(0) << endl;
//      }
      //cout << "HERE!! IN DT FIT!!! " << bg->GetParameter(0) << endl;
      //cout << "HERE!! IN DT FIT!!! " << bg->GetParameter(0) << endl;
      //cout << "HERE!! IN DT FIT!!! " << bg->GetParameter(0) << endl;
      //cout << "HERE!! IN DT FIT!!! " << bg->GetParameter(0) << endl;
      //cout << "HERE!! IN DT FIT!!! " << bg->GetParameter(0) << endl;
      //cout << "HERE!! IN DT FIT!!! " << bg->GetParameter(0) << endl;
      //cout << "HERE!! IN DT FIT!!! " << bg->GetParameter(0) << endl;
      //cout << "HERE!! IN DT FIT!!! " << bg->GetParameter(0) << endl;
      //cout << "HERE!! IN DT FIT!!! " << bg->GetParameter(0) << endl;

      //full->SetParLimits(bgRefNum,8.,8.);      
      //full->FixParameter(bgRefNum,8.);      
      //cout << "fixing to ...... " << 8. << endl;
    }
  }

  //Fit full function to histogram
  if(reactionName=="47K(d,p)"){
    hist->Fit(full, "RWQBL", "", minFit, maxFit); cout << GREEN << "FITTING WITH MAX LIKELYHOOD METHOD" << RESET << endl;
  } else if(reactionName=="47K(d,t)"){
    hist->Fit(full, "RWBL", "", minFit, maxFit); cout << GREEN << "FITTING WITH MAX LIKELYHOOD METHOD" << RESET << endl;
  }
  hist->Draw();

  //Extract fitted variables, assign them to individual fits, and draw them
  const Double_t* finalPar = full->GetParameters();
  const Double_t* finalErr = full->GetParErrors();
  for (int i=0; i<numPeaks_temp; i++){
    allPeaks[i]->SetParameters(finalPar[0+(i*3)], finalPar[1+(i*3)], finalPar[2+(i*3)]);
  }
  bg->SetParameter(0,finalPar[0]);
  bg->Draw("SAME");
  full->Draw("SAME");

  //Make irresolvable doublet clear
  if(reactionName=="47K(d,p)"){
    for (int i=0; i<numPeaks_temp; i++){
      if(abs(means_temp[i]-3.83)<0.1){
        cout << BOLDCYAN 
             << "PEAK #" << i 
             << " IS FITTING IRRESOLVABLE DOUBLET!" 
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(4003);
      }
      if(means_temp[i]>4.0){
        cout << BOLDMAGENTA 
             << "PEAK #" << i 
             << " IS FITTING UNKNOWN ZONE WITH SIGMA = "
             << full->GetParameter((i*3)+2)
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(4004);
      }
    }
  } else if(reactionName=="47K(d,t)"){
    for (int i=0; i<numPeaks_temp; i++){
	    cout << "here" << endl;
      if(abs(means_temp[i]-3.377)<0.10){
        cout << BOLDCYAN 
             << "PEAK #" << i 
             << " IS FITTING IRRESOLVABLE DOUBLET!" 
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kCyan+1);
      }
      if(abs(means_temp[i]-0.639)<0.10){
        cout << BOLDCYAN 
             << "PEAK #" << i 
             << " IS FITTING IRRESOLVABLE DOUBLET!" 
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kCyan+1);
      }
//
//
//
//
//
//	    if(abs(means[i]-3.37)<0.1){
//        cout << BOLDCYAN 
//             << "PEAK #" << i 
//             << " IS FITTING IRRESOLVABLE DOUBLET!" 
//             << RESET 
//             << endl;
//        allPeaks[i]->SetLineColor(kCyan+1);
//      }
//     if(abs(means[i]-0.639)<0.1){
//        cout << BOLDCYAN 
//             << "PEAK #" << i 
//             << " IS FITTING IRRESOLVABLE DOUBLET!" 
//             << RESET 
//             << endl;
//        allPeaks[i]->SetLineColor(kCyan+1);
//      }
//
    }
  }

  //Draw all peaks
  for (int i=0; i<numPeaks_temp; i++){
    allPeaks[i]->Draw("SAME");
  }

  //Write to screen
  cout << "===========================" << endl;
  cout << "== PEAK =========== AREA ==" << endl;
  
  //Loop over every peak
  vector<vector<double>> allpeaks;
  for(int i=0; i<numPeaks_temp; i++){
    //For AREA = HEIGHT * SIGMA * SQRT(2*PI)
    double A = (finalPar[0+(i*3)] * finalPar[2+(i*3)] * sqrt(2*pi)) / binWidth;
//    cout << "AREA = " << finalPar[0+(i*3)] << " * "
//	              << finalPar[2+(i*3)] << " * "
//		      << sqrt(2*pi)        << " = "
//		      << A                 << endl;

    double deltaA = A * sqrt( pow( finalErr[0+(i*3)]/finalPar[0+(i*3)] ,2) + pow( finalErr[2+(i*3)]/finalPar[2+(i*3)] ,2) );
    cout << "DELTAAREA = " 
	 << finalErr[0+(i*3)] << " / " 
	 << finalPar[0+(i*3)] << " and "
	 << finalErr[2+(i*3)] << " / " 
	 << finalPar[2+(i*3)] << " = " 
	 << deltaA << endl;

    cout << fixed << setprecision(3) 
	 << " #" << i << "  " 
	 << finalPar[(i*3)+1] << "\t" << setprecision(0)
	 << A << "\t+- " 
	 << deltaA << setprecision(3);
    cout << "    SQRT: " << sqrt(A) << endl;

    vector<double> onepeak; //energy, area and error for one peak
    onepeak.push_back(finalPar[(i*3)+1]);
    onepeak.push_back(A);
    onepeak.push_back(deltaA);
    allpeaks.push_back(onepeak);
    cout << "-------------" << endl;
  }

  if(removing){
    for(int b=1; b<hist->GetNbinsX()-1; b++){
      //cout << b << " " << hist->GetBinContent(b) << " " << full->Eval(hist->GetBinCenter(b)) << endl;
      fitContByBin.push_back(full->Eval(hist->GetBinCenter(b)));
    }
  }

  return allpeaks;
}

void FitKnownPeaks(TH1F* hist){
  //Shell function to call Rtrn_Arry without writing vector<vector<double>> to screen
  vector<vector<double>> shell = FitKnownPeaks_RtrnArry(hist,0.0);
}

void FitKnownPeaks_dt(TH1F* hist, bool forCS2){ 
  bgForCS2 = forCS2;
  //Shell function to call Rtrn_Arry without writing vector<vector<double>> to screen
  //vector<vector<double>> shell = FitKnownPeaks_dt_RtrnArry(hist,0.0);
  vector<vector<double>> shell = FitKnownPeaks_RtrnArry(hist,0.0);
}

TH1F* RemoveKnownPeaks(TH1F* hist){
  
  removing=true;
  vector<vector<double>> shell = FitKnownPeaks_RtrnArry(hist,0.0);

  TH1F *hcopy = (TH1F*) hist->Clone();
  hcopy->SetName("hcopy");

  hist->Draw();
  for(int b=1; b<hist->GetNbinsX()-2; b++){
    hist->SetBinContent(b, hist->GetBinContent(b) - fitContByBin.at(b));
  }
  hist->Draw();
  hcopy->Draw("same");

  removing=false;
  fitContByBin.clear();

  return hist;
}

vector<vector<double>> FitKnownPeaks_Pol2BG(TH1F* hist){
  //double minFit=-14.0, maxFit=4.644; 
  double minFit, maxFit; 
  double bgminfit, bgmaxfit;
  double binWidth = hist->GetXaxis()->GetBinWidth(3);

  double sigma = 0.0;// = 0.14;
  int numPeaks_temp = 0;
  vector<double> means_temp; 

  //Gradient on mean value
  double gradient;
  if(reactionName=="47K(d,p)"){
    sigma = 0.14;
    gradient = 0.989;
    //gradient = 0.968;
    numPeaks_temp = numPeaks;
    means_temp = means;
    minFit=-10.0;
    maxFit=4.644; 
    bgminfit=minFit;
    bgmaxfit=-0.7; 
  } else if (reactionName=="47K(d,t)"){
    sigma = 0.18;
    gradient = 0.986;
    numPeaks_temp = numPeaks_dt;
    means_temp = means_dt;
    minFit=-1.0;
    maxFit=10.0; 
    bgminfit=5.0;
    bgmaxfit=maxFit; 
  }

  string histnamepull = hist->GetName();
  cout << histnamepull << " -> " << histnamepull.substr(14,3) << endl;
  int anglenumber = stoi(histnamepull.substr(14,3));

  
  vector<double> means_GradientScaled;
  for(int i=0; i<means_temp.size(); i++){
    //if(anglenumber < 120){
    //means_GradientScaled.push_back((means_temp.at(i) * 0.987) - 0.039);
    //} else {
    //  means_GradientScaled.push_back(((means_temp.at(i) * 0.987) - 0.039) * 0.0015*(anglenumber) + 1.154);
    //}
    means_GradientScaled.push_back(means_temp.at(i) * gradient);
  }

  cout << BOLDGREEN 
       << "FITTING WITH A REAL:OBSERVED Ex GRADIENT GRADIENT OF " 
       //<< gradient 
       << "  CUSTOM EQUATION!!!!!!" 
       << RESET 
       << endl;

  //Build individual peak fit functions
  string nameBase = "Peak ";
  string function = "gaus";//"[0]*exp(-0.5*pow(((x-[1])/[2]),2))";//REGULAR GAUS
  TF1 **allPeaks = new TF1*[numPeaks_temp];
  for(int i=0; i<numPeaks_temp; i++) {
    string nameHere = nameBase;
    nameHere +=to_string(i);
    allPeaks[i] = new TF1(nameHere.c_str(), function.c_str(), minFit, maxFit);
    allPeaks[i]->SetLineColor(kBlack);  
    allPeaks[i]->SetLineStyle(7);  
    allPeaks[i]->SetNpx(500);
  } 

  //Build background function
  TF1 *bg = new TF1 ("bg","[0] + [1]*x + abs([2])*x*x", bgminfit, bgmaxfit);//-1.5);
  bg->SetParLimits(2,0,1e2);
  bg->SetLineColor(kGreen);
  //bg->SetLineStyle(9);
  bg->SetParNames("Background");
  hist->Fit(bg, "RWQBL", "", bgminfit, bgmaxfit); 
  cout << bg->GetParameter(0) << " + "
       << bg->GetParameter(1) << "x + "
       << bg->GetParameter(2) << "x*x"
       << endl;
  bg->SetRange(minFit,maxFit);

  //Build total function
  string s_full = f_full_pol2bg_string();
  TF1 *full = new TF1("fitAllPeaks", s_full.c_str(), minFit, maxFit);
  full->SetLineColor(kRed);
  const int numParams = (numPeaks_temp*3);
  for(int i=0; i<numPeaks_temp; i++) {
    //full->FixParameter((i*3)+1,means_temp.at(i)*gradient);
    full->FixParameter((i*3)+1,means_GradientScaled.at(i));
    full->FixParameter((i*3)+2,sigma);
    full->SetParameter((i*3)+0,1e1);
    full->SetParLimits((i*3)+0,0.0,1e5);
  }
  full->FixParameter(3*numPeaks_temp+0,bg->GetParameter(0));
  full->FixParameter(3*numPeaks_temp+1,bg->GetParameter(1));
  full->FixParameter(3*numPeaks_temp+2,bg->GetParameter(2));
  full->SetNpx(500);

  //Set and fix specific parameters
  for (int i=0; i<numPeaks_temp; i++){
    if(reactionName=="47K(d,p)"){
      if(means[i]>4.0){
        full->SetParameter((i*3)+2,0.23);
      }
      if(abs(means[i]-0.279)<0.05){
        full->FixParameter((i*3)+0,0.0);
      }
    } else if(reactionName=="47K(d,t)"){
      if(abs(means[i]-1.55)<0.3){
        full->SetParameter((i*3)+2,0.23);
      }
    }
  }

  //Fit full function to histogram
  hist->Fit(full, "RWQBL", "", minFit, maxFit); 
  cout << GREEN << "FITTING WITH MAX LIKELYHOOD METHOD" << RESET << endl;
  hist->Draw();

  //Extract fitted variables, assign them to individual fits, and draw them
  const Double_t* finalPar = full->GetParameters();
  const Double_t* finalErr = full->GetParErrors();
  for (int i=0; i<numPeaks_temp; i++){
    allPeaks[i]->SetParameters(finalPar[0+(i*3)], 
		               finalPar[1+(i*3)], 
			       finalPar[2+(i*3)]);
  }
  bg->Draw("SAME");
  full->Draw("SAME");

  //Make irresolvable doublet clear
  if(reactionName=="47K(d,p)"){
    for (int i=0; i<numPeaks_temp; i++){
      if(abs(means[i]-3.83)<0.1){
        cout << BOLDCYAN 
             << "PEAK #" << i 
             << " IS FITTING IRRESOLVABLE DOUBLET!" 
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kCyan+1);
      }
      if(means[i]>4.0){
        cout << BOLDMAGENTA 
             << "PEAK #" << i 
             << " IS FITTING UNKNOWN ZONE WITH SIGMA = "
             << full->GetParameter((i*3)+2)
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kMagenta);
      }
    }
  } else if(reactionName=="47K(d,t)"){
    for (int i=0; i<numPeaks_temp; i++){
      if(abs(means[i]-3.37)<0.1){
        cout << BOLDCYAN 
             << "PEAK #" << i 
             << " IS FITTING IRRESOLVABLE DOUBLET!" 
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kCyan+1);
      }
    }
  }

  //Draw all peaks
  for (int i=0; i<numPeaks_temp; i++){
    allPeaks[i]->Draw("SAME");
  }

  //Write to screen
  cout << "===========================" << endl;
  cout << "== PEAK =========== AREA ==" << endl;
  
  //Loop over every peak
  vector<vector<double>> allpeaks;
  for(int i=0; i<numPeaks_temp; i++){
    //For AREA = HEIGHT * SIGMA * SQRT(2*PI)
    double A = (finalPar[0+(i*3)] * finalPar[2+(i*3)] * sqrt(2*pi)) / binWidth;

    double deltaA = A * sqrt( pow( finalErr[0+(i*3)]/finalPar[0+(i*3)] ,2) 
		      + pow( finalErr[2+(i*3)]/finalPar[2+(i*3)] ,2) );

//    cout << "DELTAAREA = " 
//	 << finalErr[0+(i*3)] << " / " 
//	 << finalPar[0+(i*3)] << " and "
//	 << finalErr[2+(i*3)] << " / " 
//	 << finalPar[2+(i*3)] << " = " 
//	 << deltaA << endl;

    cout << fixed << setprecision(3) 
	 << " #" << i << "  " 
	 << finalPar[(i*3)+1] << "\t" << setprecision(0)
	 << A << "\t+- " 
	 << deltaA << setprecision(3);
    cout << "    SQRT: " << sqrt(A) << endl;

    vector<double> onepeak; //energy, area and error for one peak
    onepeak.push_back(finalPar[(i*3)+1]);
    onepeak.push_back(A);
    onepeak.push_back(deltaA);
    allpeaks.push_back(onepeak);
    cout << "-------------" << endl;
  }

  if(removing){
    for(int b=1; b<hist->GetNbinsX()-1; b++){
      //cout << b << " " << hist->GetBinContent(b) << " " << full->Eval(hist->GetBinCenter(b)) << endl;
      fitContByBin.push_back(full->Eval(hist->GetBinCenter(b)));
    }
  }

  return allpeaks;
}

vector<vector<double>> FitKnownPeaks_Pol4BG(TH1F* hist){
  //double minFit=-14.0, maxFit=4.644; 
  double minFit=-10.0, maxFit=4.644; 
  double binWidth = hist->GetXaxis()->GetBinWidth(3);

  double sigma = 0.0;// = 0.14;
  int numPeaks_temp = 0;
  vector<double> means_temp; 

  //FIX SHAPE OF POL4 FROM FITTING BG GATE, ONLY ALLOW VERTICAL SCALING
  double fix1 =      136.101; 
  double fix2 =      15.4108; 
  double fix3 =    -0.906266; 
  double fix4 =   -0.0737336; 
  double fix5 =   0.00402861; 


  //Gradient on mean value
  double gradient;
  if(reactionName=="47K(d,p)"){
    sigma = 0.14;
    gradient = 0.989;
    //gradient = 0.968;
    numPeaks_temp = numPeaks;
    means_temp = means;
  } else if (reactionName=="47K(d,t)"){
    sigma = 0.18;
    gradient = 0.986;
    numPeaks_temp = numPeaks_dt;
    means_temp = means_dt;
  }

  string histnamepull = hist->GetName();
  cout << histnamepull << " -> " << histnamepull.substr(14,3) << endl;
  int anglenumber = stoi(histnamepull.substr(14,3));

  
  vector<double> means_GradientScaled;
  for(int i=0; i<means_temp.size(); i++){
    //if(anglenumber < 120){
    //means_GradientScaled.push_back((means_temp.at(i) * 0.987) - 0.039);
    //} else {
    //  means_GradientScaled.push_back(((means_temp.at(i) * 0.987) - 0.039) * 0.0015*(anglenumber) + 1.154);
    //}
    means_GradientScaled.push_back(means_temp.at(i) * gradient);
  }

  cout << BOLDGREEN 
       << "FITTING WITH A REAL:OBSERVED Ex GRADIENT GRADIENT OF " 
       //<< gradient 
       << "  CUSTOM EQUATION!!!!!!" 
       << RESET 
       << endl;

  //Build individual peak fit functions
  string nameBase = "Peak ";
  string function = "gaus";//"[0]*exp(-0.5*pow(((x-[1])/[2]),2))";//REGULAR GAUS
  TF1 **allPeaks = new TF1*[numPeaks_temp];
  for(int i=0; i<numPeaks_temp; i++) {
    string nameHere = nameBase;
    nameHere +=to_string(i);
    allPeaks[i] = new TF1(nameHere.c_str(), function.c_str(), minFit, maxFit);
    allPeaks[i]->SetLineColor(kBlack);  
    allPeaks[i]->SetLineStyle(7);  
    allPeaks[i]->SetNpx(500);
  } 

  //Build background function
  TF1 *bg = new TF1 ("bg","[0] * ( [1] + [2]*x + [3]*x*x + [4]*x*x*x + [5]*x*x*x*x)", -8., -1.);//-1.5);
  bg->FixParameter(1,fix1);
  bg->FixParameter(2,fix2);
  bg->FixParameter(3,fix3);
  bg->FixParameter(4,fix4);
  bg->FixParameter(5,fix5);
  bg->SetLineColor(kGreen);
  //bg->SetLineStyle(9);
  bg->SetParNames("Background");
  hist->Fit(bg, "RWQBL", "", minFit, -1.5); 
  bg->SetRange(minFit,maxFit);

  //Build total function
  string s_full = f_full_pol2bg_string();
  TF1 *full = new TF1("fitAllPeaks", s_full.c_str(), minFit, maxFit);
  full->SetLineColor(kRed);
  const int numParams = (numPeaks_temp*3);
  for(int i=0; i<numPeaks_temp; i++) {
    //full->FixParameter((i*3)+1,means_temp.at(i)*gradient);
    full->FixParameter((i*3)+1,means_GradientScaled.at(i));
    full->FixParameter((i*3)+2,sigma);
    full->SetParameter((i*3)+0,1e1);
    full->SetParLimits((i*3)+0,0.0,1e5);
  }
  full->FixParameter(3*numPeaks_temp+0,bg->GetParameter(0));
  full->FixParameter(3*numPeaks_temp+1,fix1);
  full->FixParameter(3*numPeaks_temp+2,fix2);
  full->FixParameter(3*numPeaks_temp+3,fix3);
  full->FixParameter(3*numPeaks_temp+4,fix4);
  full->FixParameter(3*numPeaks_temp+5,fix5);

  full->SetNpx(500);

  //Set and fix specific parameters
  for (int i=0; i<numPeaks; i++){
    if(means[i]>4.0){
      full->SetParameter((i*3)+2,0.23);
    }
    if(abs(means[i]-0.279)<0.05){
      full->FixParameter((i*3)+0,0.0);
    }
  }

  //Fit full function to histogram
  hist->Fit(full, "RWQBL", "", minFit, maxFit); 
  cout << GREEN << "FITTING WITH MAX LIKELYHOOD METHOD" << RESET << endl;
  hist->Draw();

  //Extract fitted variables, assign them to individual fits, and draw them
  const Double_t* finalPar = full->GetParameters();
  const Double_t* finalErr = full->GetParErrors();
  for (int i=0; i<numPeaks_temp; i++){
    allPeaks[i]->SetParameters(finalPar[0+(i*3)], 
		               finalPar[1+(i*3)], 
			       finalPar[2+(i*3)]);
  }
  bg->Draw("SAME");
  full->Draw("SAME");

  //Make irresolvable doublet clear
  if(reactionName=="47K(d,p)"){
    for (int i=0; i<numPeaks_temp; i++){
      if(abs(means[i]-3.83)<0.1){
        cout << BOLDCYAN 
             << "PEAK #" << i 
             << " IS FITTING IRRESOLVABLE DOUBLET!" 
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kCyan+1);
      }
      if(means[i]>4.0){
        cout << BOLDMAGENTA 
             << "PEAK #" << i 
             << " IS FITTING UNKNOWN ZONE WITH SIGMA = "
             << full->GetParameter((i*3)+2)
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kMagenta);
      }
    }
  } else if(reactionName=="47K(d,t)"){
    for (int i=0; i<numPeaks_temp; i++){
	    cout << "here" << i << endl;
      if(abs(means[i]-3.377)<0.05){
        cout << BOLDCYAN 
             << "PEAK #" << i 
             << " IS FITTING IRRESOLVABLE DOUBLET!" 
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kCyan+1);
      }
      if(abs(means[i]-0.639)<0.05){
        cout << BOLDCYAN 
             << "PEAK #" << i 
             << " IS FITTING IRRESOLVABLE DOUBLET!" 
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kCyan+1);
      }

    }
  }

  //Draw all peaks
  for (int i=0; i<numPeaks_temp; i++){
    allPeaks[i]->Draw("SAME");
  }

  //Write to screen
  cout << "===========================" << endl;
  cout << "== PEAK =========== AREA ==" << endl;
  
  //Loop over every peak
  vector<vector<double>> allpeaks;
  for(int i=0; i<numPeaks_temp; i++){
    //For AREA = HEIGHT * SIGMA * SQRT(2*PI)
    double A = (finalPar[0+(i*3)] * finalPar[2+(i*3)] * sqrt(2*pi)) / binWidth;

    double deltaA = A * sqrt( pow( finalErr[0+(i*3)]/finalPar[0+(i*3)] ,2) 
		      + pow( finalErr[2+(i*3)]/finalPar[2+(i*3)] ,2) );

//    cout << "DELTAAREA = " 
//	 << finalErr[0+(i*3)] << " / " 
//	 << finalPar[0+(i*3)] << " and "
//	 << finalErr[2+(i*3)] << " / " 
//	 << finalPar[2+(i*3)] << " = " 
//	 << deltaA << endl;

    cout << fixed << setprecision(3) 
	 << " #" << i << "  " 
	 << finalPar[(i*3)+1] << "\t" << setprecision(0)
	 << A << "\t+- " 
	 << deltaA << setprecision(3);
    cout << "    SQRT: " << sqrt(A) << endl;

    vector<double> onepeak; //energy, area and error for one peak
    onepeak.push_back(finalPar[(i*3)+1]);
    onepeak.push_back(A);
    onepeak.push_back(deltaA);
    allpeaks.push_back(onepeak);
    cout << "-------------" << endl;
  }

  if(removing){
    for(int b=1; b<hist->GetNbinsX()-1; b++){
      //cout << b << " " << hist->GetBinContent(b) << " " << full->Eval(hist->GetBinCenter(b)) << endl;
      fitContByBin.push_back(full->Eval(hist->GetBinCenter(b)));
    }
  }

  return allpeaks;
}

vector<vector<double>> FitKnownPeaks_SkewedGaussBG(TH1F* hist){
  //
  //24Aug23 - BG gound from fitting skewed gaussian to 24Aug23_BackgroundShape.root,
  //which was itself determined by subtraction old low-bg gate from new high-bg gate.
  //
  
  //double minFit=-14.0, maxFit=4.644; 
  double minFit=-10.0, maxFit=4.644; 
  double binWidth = hist->GetXaxis()->GetBinWidth(3);

  double sigma = 0.0;// = 0.14;
  int numPeaks_temp = 0;
  vector<double> means_temp; 

  //FIX SHAPE OF SKEW FROM FITTING BG GATE, ONLY ALLOW VERTICAL SCALING
  double fix1 = +6.54282e+00; 
  double fix2 = -3.17214e-01; 
  double fix3 = +5.64278e+00; 


  //Gradient on mean value
  double gradient;
  if(reactionName=="47K(d,p)"){
    sigma = 0.14;
    gradient = 0.989;
    //gradient = 0.968;
    numPeaks_temp = numPeaks;
    means_temp = means;
  } else if (reactionName=="47K(d,t)"){
    sigma = 0.18;
    gradient = 0.986;
    numPeaks_temp = numPeaks_dt;
    means_temp = means_dt;
  }

  string histnamepull = hist->GetName();
  cout << histnamepull << " -> " << histnamepull.substr(14,3) << endl;
  int anglenumber = stoi(histnamepull.substr(14,3));
//  int anglenumber = 1;

  
  vector<double> means_GradientScaled;
  for(int i=0; i<means_temp.size(); i++){
    //if(anglenumber < 120){
    //means_GradientScaled.push_back((means_temp.at(i) * 0.987) - 0.039);
    //} else {
    //  means_GradientScaled.push_back(((means_temp.at(i) * 0.987) - 0.039) * 0.0015*(anglenumber) + 1.154);
    //}
    means_GradientScaled.push_back(means_temp.at(i) * gradient);
  }

  cout << BOLDGREEN 
       << "FITTING WITH A REAL:OBSERVED Ex GRADIENT GRADIENT OF " 
       << gradient 
       //<< "  CUSTOM EQUATION!!!!!!" 
       << RESET 
       << endl;

  //Build individual peak fit functions
  string nameBase = "Peak ";
  string function = "gaus";//"[0]*exp(-0.5*pow(((x-[1])/[2]),2))";//REGULAR GAUS
  TF1 **allPeaks = new TF1*[numPeaks_temp];
  for(int i=0; i<numPeaks_temp; i++) {
    string nameHere = nameBase;
    nameHere +=to_string(i);
    allPeaks[i] = new TF1(nameHere.c_str(), function.c_str(), minFit, maxFit);
    allPeaks[i]->SetLineColor(kBlack);  
    allPeaks[i]->SetLineStyle(7);  
    allPeaks[i]->SetNpx(500);
  } 

  //Build background function
  TF1 *bg = new TF1 ("bg","2.*gaus(x-[3],[0],0,[1])*ROOT::Math::normal_cdf([2]*(x-[3]),1,0)",
		          -15., 10.);
  bg->FixParameter(1,fix1);
  bg->FixParameter(2,fix2);
  bg->FixParameter(3,fix3);
  bg->SetLineColor(kGreen);
  //bg->SetLineStyle(9);
  bg->SetParNames("Background");
  hist->Fit(bg, "RWQBL", "", minFit, -3.0);// -1.5); 
  bg->SetRange(minFit,maxFit);

  //Build total function
  string s_full = f_full_skewgaussbg_string();
  TF1 *full = new TF1("fitAllPeaks", s_full.c_str(), minFit, maxFit);
  full->SetLineColor(kRed);
  const int numParams = (numPeaks_temp*3);
  for(int i=0; i<numPeaks_temp; i++) {
    //full->FixParameter((i*3)+1,means_temp.at(i)*gradient);
    full->FixParameter((i*3)+1,means_GradientScaled.at(i));
    full->FixParameter((i*3)+2,sigma);
    full->SetParameter((i*3)+0,1e1);
    full->SetParLimits((i*3)+0,0.0,1e5);
  }
  full->FixParameter(3*numPeaks_temp+0,bg->GetParameter(0));
  full->FixParameter(3*numPeaks_temp+1,fix1);
  full->FixParameter(3*numPeaks_temp+2,fix2);
  full->FixParameter(3*numPeaks_temp+3,fix3);

  full->SetNpx(500);

  //Set and fix specific parameters
  for (int i=0; i<numPeaks; i++){
    if(means[i]>4.0){
      full->SetParameter((i*3)+2,0.23);
    }
    if(abs(means[i]-0.279)<0.05){
      full->FixParameter((i*3)+0,0.0);
    }
  }

  //Fit full function to histogram
  hist->Fit(full, "RWQBL", "", minFit, maxFit); 
  cout << GREEN << "FITTING WITH MAX LIKELYHOOD METHOD" << RESET << endl;
  hist->Draw();

  //Extract fitted variables, assign them to individual fits, and draw them
  const Double_t* finalPar = full->GetParameters();
  const Double_t* finalErr = full->GetParErrors();
  for (int i=0; i<numPeaks_temp; i++){
    allPeaks[i]->SetParameters(finalPar[0+(i*3)], 
		               finalPar[1+(i*3)], 
			       finalPar[2+(i*3)]);
  }
  bg->Draw("SAME");
  full->Draw("SAME");

  //Make irresolvable doublet clear
  if(reactionName=="47K(d,p)"){
    for (int i=0; i<numPeaks_temp; i++){
      if(abs(means[i]-3.83)<0.1){
        cout << BOLDCYAN 
             << "PEAK #" << i 
             << " IS FITTING IRRESOLVABLE DOUBLET!" 
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kCyan+1);
      }
      if(means[i]>4.0){
        cout << BOLDMAGENTA 
             << "PEAK #" << i 
             << " IS FITTING UNKNOWN ZONE WITH SIGMA = "
             << full->GetParameter((i*3)+2)
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kMagenta);
      }
    }
  } else if(reactionName=="47K(d,t)"){
    for (int i=0; i<numPeaks_temp; i++){
      if(abs(means[i]-3.37)<0.1){
        cout << BOLDCYAN 
             << "PEAK #" << i 
             << " IS FITTING IRRESOLVABLE DOUBLET!" 
             << RESET 
             << endl;
        allPeaks[i]->SetLineColor(kCyan+1);
      }
    }
  }

  //Draw all peaks
  for (int i=0; i<numPeaks_temp; i++){
    allPeaks[i]->Draw("SAME");
  }

  //Write to screen
  cout << "===========================" << endl;
  cout << "== PEAK =========== AREA ==" << endl;
  
  //Loop over every peak
  vector<vector<double>> allpeaks;
  for(int i=0; i<numPeaks_temp; i++){
    //For AREA = HEIGHT * SIGMA * SQRT(2*PI)
    double A = (finalPar[0+(i*3)] * finalPar[2+(i*3)] * sqrt(2*pi)) / binWidth;

    double deltaA = A * sqrt( pow( finalErr[0+(i*3)]/finalPar[0+(i*3)] ,2) 
		      + pow( finalErr[2+(i*3)]/finalPar[2+(i*3)] ,2) );

//    cout << "DELTAAREA = " 
//	 << finalErr[0+(i*3)] << " / " 
//	 << finalPar[0+(i*3)] << " and "
//	 << finalErr[2+(i*3)] << " / " 
//	 << finalPar[2+(i*3)] << " = " 
//	 << deltaA << endl;

    cout << fixed << setprecision(3) 
	 << " #" << i << "  " 
	 << finalPar[(i*3)+1] << "\t" << setprecision(0)
	 << A << "\t+- " 
	 << deltaA << setprecision(3);
    cout << "    SQRT: " << sqrt(A) << endl;

    vector<double> onepeak; //energy, area and error for one peak
    onepeak.push_back(finalPar[(i*3)+1]);
    onepeak.push_back(A);
    onepeak.push_back(deltaA);
    allpeaks.push_back(onepeak);
    cout << "-------------" << endl;
  }

  if(removing){
    for(int b=1; b<hist->GetNbinsX()-1; b++){
      //cout << b << " " << hist->GetBinContent(b) << " " << full->Eval(hist->GetBinCenter(b)) << endl;
      fitContByBin.push_back(full->Eval(hist->GetBinCenter(b)));
    }
  }

  return allpeaks;
}




