#!/bin/bash

rm RunToTreat_AutoGenerated.txt
rm ./Reaction/Auto.reaction

XYZTdate="18Oct22"
#XYZTdate="25Jul23"
sp=" "

dfile="./Detector/mugast_"$XYZTdate".detector"
rfile="./Reaction/Auto.reaction"

E=$(echo "scale=3; $2/1000" | bc -l)

#Boilerplate
echo -e "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" 		  >> ./Reaction/Auto.reaction
echo -e "Beam" 						  >> ./Reaction/Auto.reaction
echo -e "$sp""Particle=""$sp""47K" 			  >> ./Reaction/Auto.reaction
echo -e "$sp""ExcitationEnergy=""$sp""0""$sp""MeV" 	  >> ./Reaction/Auto.reaction
echo -e "$sp""Energy=""$sp""354.75""$sp""MeV" 		  >> ./Reaction/Auto.reaction
echo -e "$sp""SigmaEnergy=""$sp""0.""$sp"" MeV" 	  >> ./Reaction/Auto.reaction
echo -e "$sp""SigmaThetaX=""$sp""0.0""$sp""deg" 	  >> ./Reaction/Auto.reaction
echo -e "$sp""SigmaPhiY=""$sp""0.0""$sp""deg"	 	  >> ./Reaction/Auto.reaction
echo -e "$sp""SigmaX=""$sp""2.0""$sp""millimeter" 	  >> ./Reaction/Auto.reaction
echo -e "$sp""SigmaY=""$sp""2.0""$sp""millimeter"	  >> ./Reaction/Auto.reaction
echo -e "$sp""MeanThetaX=""$sp""0""$sp""deg"	  	  >> ./Reaction/Auto.reaction
echo -e "$sp""MeanPhiY=""$sp""0""$sp""deg" 		  >> ./Reaction/Auto.reaction

#Define XY of given XYZT date
echo -e "$sp""MeanX=""$sp""-4.1561""$sp""millimeter" 	  >> ./Reaction/Auto.reaction
echo -e "$sp""MeanY=""$sp""+0.4701""$sp""millimeter" 	  >> ./Reaction/Auto.reaction
echo -e "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" 		  >> ./Reaction/Auto.reaction
echo -e "TwoBodyReaction" 				  >> ./Reaction/Auto.reaction
echo -e "$sp""Beam=""$sp""47K" 				  >> ./Reaction/Auto.reaction

#Define reaction
if [[ "$1" == "47Kdp" ]]; then
  echo "Running 47Kdp"
  echo -e "$sp""Target=""$sp""2H" 			  >> ./Reaction/Auto.reaction
  echo -e "$sp""Light=""$sp""1H" 			  >> ./Reaction/Auto.reaction
  echo -e "$sp""Heavy=""$sp""48K" 			  >> ./Reaction/Auto.reaction
elif [[ "$1" == "47Kdt" ]]; then
  echo "Running 47Kdt"
  echo -e "$sp""Target=""$sp""2H" 			  >> ./Reaction/Auto.reaction
  echo -e "$sp""Light=""$sp""3H" 			  >> ./Reaction/Auto.reaction
  echo -e "$sp""Heavy=""$sp""46K" 			  >> ./Reaction/Auto.reaction
elif [[ "$1" == "47Kdd" ]]; then
  echo "Running 47Kdd"
  echo -e "$sp""Target=""$sp""2H" 			  >> ./Reaction/Auto.reaction
  echo -e "$sp""Light=""$sp""2H" 			  >> ./Reaction/Auto.reaction
  echo -e "$sp""Heavy=""$sp""47K" 			  >> ./Reaction/Auto.reaction
elif [[ "$1" == "47Kpp" ]]; then
  echo "Running 47Kpp"
  echo -e "$sp""Target=""$sp""1H" 			  >> ./Reaction/Auto.reaction
  echo -e "$sp""Light=""$sp""1H" 			  >> ./Reaction/Auto.reaction
  echo -e "$sp""Heavy=""$sp""47K" 			  >> ./Reaction/Auto.reaction
fi

#Define heavy recoil excitation & finish
echo -e "$sp""ExcitationEnergyLight=""$sp""0.0""$sp""MeV" >> ./Reaction/Auto.reaction
echo -e "$sp""ExcitationEnergyHeavy=""$sp""$E""$sp""MeV"  >> ./Reaction/Auto.reaction
echo -e "$sp""LabCrossSectionPath=""$sp""flat.txt""$sp""CSR" >> ./Reaction/Auto.reaction
echo -e "$sp""ShootLight=""$sp""1" 			  >> ./Reaction/Auto.reaction
echo -e "$sp""ShootHeavy=""$sp""0" 			  >> ./Reaction/Auto.reaction

#====================================================

cd ~/Programs/nptool/Projects/e793s;
cmake ./;
make -j6;

directory='/home/charlottepaxman/Programs/nptool/Outputs/Simulation/'

nameconstruct=$XYZTdate"_"$1"_"$2
echo "Name: $nameconstruct"
echo "Reaction file: $rfile"
echo "Detector file: $dfile"

for x in 1 2 3 4 5 #6 7 8 9 10
do
        outname=$nameconstruct"-"$x
	npsimulation -D $dfile -E $rfile -B ./runsimulation.mac --random-seed $RANDOM -O $outname;
done

outfile="Sim_"$nameconstruct

echo "TTreeName" >> RunToTreat_AutoGenerated.txt
echo " SimulatedTree" >> RunToTreat_AutoGenerated.txt
echo "RootFileName" >> RunToTreat_AutoGenerated.txt

for x in 1 2 3 4 5 #6 7 8 9 10
do
	echo "$sp""$directory""$nameconstruct""-""$x"".root" >> RunToTreat_AutoGenerated.txt
done

npanalysis --definition Sim -R RunToTreat_AutoGenerated.txt -E $rfile -D $dfile -O $outfile;

mvname="./macro/SolidAngle_HistFiles/SAHF_"$nameconstruct".root"
mv SolidAngle_HistFile_New.root $mvname
