int GetZHighestYield(string);

TGraph* g_light;
TGraph* g_heavy;
TGraphErrors* g_sym;

TGraph* g_light2;
TGraph* g_heavy2;
TGraph* g_light3;
TGraph* g_heavy3;


////////////////////////////////////////////
void HighestYield()
{
  gROOT->SetStyle("pierre_style");
  
  string filename = "asymmetry_file.dat";
  //string filename = "list_asy.dat";
  //string filename = "list_all.dat";
  //string filename = "list_s455.dat";
  ifstream ifile;
  ifile.open(filename.c_str());

  g_light = new TGraph();
  g_light2 = new TGraph();
  g_light3 = new TGraph();
  g_heavy = new TGraph();
  g_heavy2 = new TGraph();
  g_heavy3 = new TGraph();
  g_sym = new TGraphErrors();


  int Z;
  int A;
  int N;
  int i=0;
  NPL::Particle* iso;
  double asy;

  while(ifile>>Z>>N>>asy){
    A = Z+N;
    //ifile >> Z >> A;
    iso = new NPL::Particle(Z,A);
    string isoname = iso->GetName();

    double fissility = Z*Z/pow(A,1./3.);
    //double fissility = (double)Z*(double)Z/(double)A;
    if(Z==92)
      isoname.resize(4);
    else
      isoname.resize(5);
    string yield_filename = "dat/yield_" + isoname + ".dat";
   
    int z_light = GetZHighestYield(yield_filename);
    int z_heavy = Z - z_light;
    double z_sym = (double)Z/2.;

    if((Z<83 || Z>88) && asy>10 && z_light>33){
    //if(asy>0 && z_light>33){
      g_light->SetPoint(i,fissility,z_light);
      g_light2->SetPoint(i,Z,z_light);
      g_light3->SetPoint(i,N,z_light);
      g_heavy->SetPoint(i,fissility,z_heavy);
      g_heavy2->SetPoint(i,Z,z_heavy);
      g_heavy3->SetPoint(i,N,z_heavy);
      //g_sym->SetPoint(i,fissility,z_sym);
      //g_sym->SetPointError(i,0.2,0.2);

      cout << Z << " " << A << " / " << z_light << " - " << z_heavy << endl;
      i++;
    }
  }
  g_sym->SetPoint(0,77*77./pow(174,1./3.),38.5);
  g_sym->SetPointError(0,0.,0.1);
  g_sym->SetPoint(1,93*93./pow(237,1./3.),46.5);
  g_sym->SetPointError(1,0.,0.1);



  // *************************************************** //
  TH2F* h2 = new TH2F("h2","h2",100,1060,1410,100,33,56);
  //TH2F* h2 = new TH2F("h2","h2",100,0,100,100,30,60);
  h2->GetXaxis()->SetTitle("Z^{2}_{CN}/A^{1/3}_{CN}");
  h2->GetYaxis()->SetTitle("Z_{FF}");
  h2->GetXaxis()->CenterTitle();
  h2->GetYaxis()->CenterTitle();
  h2->GetXaxis()->SetLabelSize(0.06);
  h2->GetXaxis()->SetTitleSize(0.06);
  h2->GetXaxis()->SetTitleOffset(1.1);
  h2->GetYaxis()->SetLabelSize(0.06);
  h2->GetYaxis()->SetTitleSize(0.06);
  h2->GetYaxis()->SetTitleOffset(1.1);
  h2->GetXaxis()->SetNdivisions(505);
  h2->GetYaxis()->SetNdivisions(505);


  g_light->SetMarkerStyle(8);
  g_light->SetMarkerColor(2);
  g_light->SetMarkerSize(2);
  g_heavy->SetMarkerStyle(33);
  g_heavy->SetMarkerColor(4);
  g_heavy->SetMarkerSize(2);

  g_sym->SetMarkerColor(1);
  g_sym->SetMarkerStyle(21);

  TCanvas* c1 = new TCanvas("c1","c1",800,800);
  c1->cd();
  h2->Draw();
  g_light->Draw("psame");
  g_heavy->Draw("psame");

  TLatex* t36 = new TLatex(1010, 35.5,"Z_{L}#approx36");
  TLatex* t54 = new TLatex(1410, 53.5,"Z_{H}#approx54");
  t36->SetTextColor(2);
  t54->SetTextColor(4);
  t36->SetTextSize(0.03);
  t54->SetTextSize(0.03);
  //t36->Draw("same");
  //t54->Draw("same");
  g_sym->SetFillColor(1);
  g_sym->Draw("3same");


  // *************************************************** //
  TH2F* h3 = new TH2F("h3","h3",100,76,94,100,33,56);
  h3->GetXaxis()->SetTitle("Z_{CN}");
  h3->GetYaxis()->SetTitle("Z_{FF}");
  h3->GetXaxis()->CenterTitle();
  h3->GetYaxis()->CenterTitle();
  g_light2->SetMarkerStyle(8);
  g_light2->SetMarkerColor(2);
  g_light2->SetMarkerSize(2);
  g_heavy2->SetMarkerStyle(33);
  g_heavy2->SetMarkerColor(4);
  g_heavy2->SetMarkerSize(2);

  /*TCanvas* c2 = new TCanvas("c2","c2",800,800);
  c2->cd();
  h3->Draw(); 
  g_heavy2->Draw("psame");
  g_light2->Draw("psame");*/


  // *************************************************** //
  TH2F* h4 = new TH2F("h4","h4",100,90,150,100,33,56);
  h4->GetXaxis()->SetTitle("N_{CN}");
  h4->GetYaxis()->SetTitle("Z_{FF}");
  h4->GetXaxis()->CenterTitle();
  h4->GetYaxis()->CenterTitle();
  g_light3->SetMarkerStyle(8);
  g_light3->SetMarkerColor(2);
  g_light3->SetMarkerSize(2);
  g_heavy3->SetMarkerStyle(33);
  g_heavy3->SetMarkerColor(4);
  g_heavy3->SetMarkerSize(2);

  /*TCanvas* c3 = new TCanvas("c3","c3",800,800);
  c3->cd();
  h4->Draw(); 
  g_heavy3->Draw("psame");
  g_light3->Draw("psame");*/


  // Theory results //
  TGraph* gZL = new TGraph();
  TGraph* gZH = new TGraph();

  string filename_th = "Theory/Z_FF_Bernard.dat";
  ifstream ifile_th;
  ifile_th.open(filename_th.c_str());
  int Z_CN;
  int A_CN;
  int Z_L;
  int Z_H;
  int i_th=0;
  while(ifile_th>>Z_CN>>A_CN>>Z_L>>Z_H){
    i_th++;
    gZL->SetPoint(i_th,pow(Z_CN,2)/pow(A_CN,1./3.),Z_L);
    gZH->SetPoint(i_th,pow(Z_CN,2)/pow(A_CN,1./3.),Z_H);
  }

  gZL->SetMarkerStyle(22);
  gZH->SetMarkerStyle(23);
  //gZL->SetMarkerColor(8);
  gZL->SetMarkerColor(1);
  //gZH->SetMarkerColor(kGray+1);
  gZH->SetMarkerColor(1);
  gZL->SetMarkerSize(1.3);
  gZH->SetMarkerSize(1.3);
  gZL->SetLineWidth(4);
  gZH->SetLineWidth(4);

  c1->cd();
  //gZL->Draw("psame");
  //gZH->Draw("psame");
}

////////////////////////////////////////////
int GetZHighestYield(string filename)
{
  ifstream ifile;

  cout << "*** opening " << filename << endl;
  ifile.open(filename.c_str());

  vector<int> v_Z;
  vector<double> v_yield;
  vector<double> v_yield_err;

  int Z;
  double yield;
  double yield_err;
  double yield_max=0;
  int i=0;
  int imax=0;
  while(ifile >> Z >> yield >> yield_err){
    v_Z.push_back(Z);
    v_yield.push_back(yield);

    if(yield>yield_max){
      yield_max = yield;
      imax=i;
    }
    i++;

  }
  ifile.close();

  int z_max = v_Z[imax];

  return z_max;
}


